;*******************************************************************************
; Programa: Incrementa um digito no display
; arquivo: display1.asm
;*******************************************************************************
            list p=16f84
;
            include "P16F84.INC"
;
            __config _CP_OFF & _PWRTE_ON & _WDT_OFF & _XT_OSC
;*******************************************************************************
;           area de declaracao de equ
;*******************************************************************************
            org h'000c'
Cont        res     1
;*******************************************************************************
;           vetor do reset
;*******************************************************************************
            org h'0000'         ;endereco do vetor do reset
            goto Start          ;vai para o inicio do programa
;*******************************************************************************
;           Area de subrotinas
;*******************************************************************************
;           Display
;*******************************************************************************
Display:    clrf PORTA
            movf Cont,W         ;Salva contador em W
            andlw 0x0f          ;Zera NIBBLE superior
            call Table          ;Converte p/formato do display
            movwf PORTB         ;Transfere para DISPLAY
            bsf PORTA,3
            return
;*******************************************************************************
;           Table - retorna em W codigo relativo
;*******************************************************************************
Table:      addwf PCL,F         ;soma W com PCL e executa salto relativo
            retlw 0xeb          ;num 0
            retlw 0x48          ;num 1
            retlw 0xd3          ;num 2
            retlw 0xda          ;num 3
            retlw 0x78          ;num 4
            retlw 0xba          ;num 5
            retlw 0xbb          ;num 6
            retlw 0xc8          ;num 7
            retlw 0xfb          ;num 8
            retlw 0xfa          ;num 9
            retlw 0xf9          ;num a
            retlw 0x3b          ;num b
            retlw 0xa3          ;num c
            retlw 0x5b          ;num d
            retlw 0xb3          ;num e
            retlw 0xb1          ;num f
;*******************************************************************************
;           delay (utiliza TMR0 sem habilitar interrupcao)
;*******************************************************************************
delay:      clrf TMR0           ;zera TMR0
            movlw 0ffh          ;valor maximo do TMR0
            xorwf TMR0,W        ;compara W com TMR0
            btfss STATUS,Z      ;se igual finaliza funcao
            goto $-3            ;senao repete o ciclo
            return
;*******************************************************************************
;           segmento de inicializacao
;*******************************************************************************
Start:      bsf STATUS,RP0      ;ativa Bank1
            movlw 0xc7          ;configura o registro option habilitando
            movwf OPTION_REG    ;timer0 com prescaler 1:256
            clrf TRISB          ;PORTB = SAIDA
            clrf TRISA          ;PORTA = SAIDA
            bcf STATUS,RP0      ;ativa Bank0
;*******************************************************************************
;           segmento principal
;*******************************************************************************
            clrf Cont
            clrf PORTB
            clrf PORTA
loop:       call Display
            incf Cont,F
            call delay
            call delay
            call delay
            call delay
            call delay
            call delay
            goto loop
;*******************************************************************************
            end
;*******************************************************************************
