;*******************************************************************************
; Programa: pisca led no Portb
; arquivo: ledxt.asm
;*******************************************************************************
            list p=16f84
;
            include "P16F84.INC"
;
            __config _CP_OFF & _PWRTE_ON & _WDT_OFF & _XT_OSC
;*******************************************************************************
;           area de declaracao de equ
;*******************************************************************************
led1        equ     0           ;determina saida para o led
led2        equ     7
;*******************************************************************************
;           vetor do reset
;*******************************************************************************
            org 0h              ;endereco do vetor do reset
            goto start          ;vai para o inicio do programa
;*******************************************************************************
;           Area de subrotinas
;*******************************************************************************
;           delay (utiliza TMR0 sem habilitar interrupcao)
;*******************************************************************************
delay:      clrf TMR0           ;zera TMR0
            movlw 0ffh          ;valor maximo do TMR0
            xorwf TMR0,W        ;compara W com TMR0
            btfss STATUS,Z      ;se igual finaliza funcao
            goto $-3            ;senao repete o ciclo
            return
;*******************************************************************************
;           segmento de inicializacao
;*******************************************************************************
start:      bsf STATUS,RP0      ;ativa Bank1
            movlw 0xc7          ;configura o registro option habilitando
            movwf OPTION_REG    ;timer0 com prescaler 1:256
            clrf TRISB          ;configura PORTB como saida (todos os bits)
            bcf STATUS,RP0      ;ativa Bank0
;*******************************************************************************
;           segmento principal
;*******************************************************************************
            movlw 0             ;inicializa PORTB
            movwf PORTB
loop:       bsf PORTB,led1
            bcf PORTB,led2
            call delay
            call delay
            call delay
            bcf PORTB,led1
            bsf PORTB,led2
            call delay
            call delay
            btfss PORTA,0
            goto loop           ;repete o ciclo
            btfsc PORTA,0
            goto $ - 1
            goto loop
;*******************************************************************************
            end
;*******************************************************************************
