;*******************************************************************************
; Programa: sequencial de led no Portb
; arquivo: seqrc.asm
;*******************************************************************************
            list p=16f84
;
            include "P16F84.INC"
;
            __config _CP_OFF & _PWRTE_ON & _WDT_OFF & _RC_OSC
;*******************************************************************************
;           vetor do reset
;*******************************************************************************
            org 0h              ;endereco do vetor do reset
            goto start          ;vai para o inicio do programa
;*******************************************************************************
;           Area de subrotinas
;*******************************************************************************
;           delay (utiliza TMR0 sem habilitar interrupcao)
;*******************************************************************************
delay:      clrf TMR0           ;zera TMR0
            movlw 0ffh          ;valor maximo do TMR0
            xorwf TMR0,W        ;compara W com TMR0
            btfss STATUS,Z      ;se igual finaliza funcao
            goto $-3            ;senao repete o ciclo
            return
;*******************************************************************************
;           segmento de inicializacao
;*******************************************************************************
start:      bsf STATUS,RP0      ;ativa Bank1
            movlw 0xc7          ;configura o registro option habilitando
            movwf OPTION_REG    ;timer0 com prescaler 1:256
            clrf TRISB          ;configura PORTB como saida (todos os bits)
            bcf STATUS,RP0      ;ativa Bank0
;*******************************************************************************
;           segmento principal
;*******************************************************************************
            movlw 0x01          ;inicializa PORTB
            movwf PORTB
            bcf STATUS,C        ;zera carry
loop:       call delay
            rrf PORTB,F         ;desloca bit para direita em PORTB
            goto loop           ;repete o ciclo
;*******************************************************************************
            end
;*******************************************************************************
