#include <16f84A.h>

#define T1SEG 20
#define T50MSEG 256-195

char get_led(char W)
{
    skip(W);
#pragma return[4] = 0b.0010.0001 0b.0001.0100 0b.0001.0010 0b0100.0001
}

char get_time(char W)
{
    skip(W);
#pragma return[4] = 1 4 1 2
}

void wait_time(char tempo)
{
    char nx1seg;
    char var1seg;

    for (nx1seg = 0; nx1seg < tempo; nx1seg++)
    {
        for (var1seg = 0; var1seg < T1SEG; var1seg++)
        {
             TMR0 = T50MSEG;
             while (TMR0 != 0);
        }
    }
}

void main(void)
{
    char estado, tempo;

    PORTA = 0b.0000.0000;  
    TRISA = 0b.1111.1111;  
    PORTB = 0b.0000.0000;
    TRISB = 0b.0000.0000;
    OPTION = 0x07;
    TMR0 = 0x00;
    estado = 0;

    for (;;) {
	PORTB = get_led(estado);
	tempo = get_time(estado); 
	wait_time(tempo); 
        estado++;
        if (estado > 3) estado = 0;
    }	
}



