;================================================================
;=								=
;=	Titulo  : Controlador para Semaforos			=
;=	Arquivo : Semaforo.ASM					=
;=								=
;================================================================

        PROCESSOR 16F84
	INCLUDE <P16F84A.INC>
	RADIX	HEX		; DEFINE BASE HEXADECIMAL

NX1SEG  EQU     0X20            ; VARIAVEL AUXILIAR DE TEMPO
VAR1SEG EQU     0X21            ; VARIAVEL AUXILIAR DE TEMPO
ESTADO  EQU     0X22            ; VARIAVEL ESTADO

T1SEG	EQU	D'20'		; VALOR PARA TEMPO 1 SEG
T50MSEG	EQU	D'256' - D'195'	; VALOR PARA TEMPO 50MSEG

TMP_VDA	EQU	0X04		; TEMPO DE VERDE DA TRANSV. A
TMP_AM	EQU	0X01		; TEMPO DE AMARELO
TMP_VDB	EQU	0X02		; TEMPO DE VERDE DA TRANSV. B

ESTADO1 EQU     B'00100001'     ; AMARELO NA TRANSV. B
ESTADO2 EQU     B'00010100'     ; VERDE NA TRANSV. A
ESTADO3 EQU     B'00010010'     ; AMARELO NA TRANSV. A
ESTADO4 EQU     B'01000001'     ; VERDE NA TRANSV. B

;================================================================

	ORG	0X000		; SETA ENDERECO DE MEMORIA
INICIO:
	BCF	STATUS,RP0	; BANCO 0
	CLRF	PORTB		; APAGA TODOS LEDS
	BSF	STATUS,RP0	; BANCO 1
	MOVLW	0X07		; INICIALIZA TIMER 0 COMO TIMER
	MOVWF	OPTION_REG	; PRE-ESCALA 1:256
	CLRF	TRISB		; PORTB = SAIDA
	BCF	STATUS,RP0	; BANCO 0
	CLRF	TMR0		; LIMPA VARIAVEIS
	CLRF	ESTADO
LOOP:	
	MOVF	ESTADO,W
	CALL	TAB_ESTADO	; CARREGA LEDS
	MOVWF	PORTB		; ACENDE LEDS REFERENTES AO ESTADO
	MOVF	ESTADO,W		
	CALL	TAB_TEMPO	; CARREGA TEMPO	
	CALL	TEMPO		; AGUARDA TEMPO DO ESTADO
	INCF	ESTADO,F
        MOVF    ESTADO,W
	XORLW  	D'4'       	; VERIFICA SE (0 <= ESTADO < 4)
        BTFSC   STATUS,Z 
	CLRF	ESTADO
	GOTO	LOOP

TAB_ESTADO:
	ADDWF	PCL,F		; COMPUTA ESTADO (PESQUISA TABELA)
	RETLW	ESTADO1
	RETLW	ESTADO2
	RETLW	ESTADO3
	RETLW	ESTADO4

TAB_TEMPO:
	ADDWF	PCL,F
	RETLW	TMP_AM
	RETLW	TMP_VDA
	RETLW	TMP_AM
	RETLW	TMP_VDB



TEMPO:
	MOVWF	NX1SEG		; CARREGA TEMPO DA TABELA (N SEG)
TMP3:
	MOVLW	T1SEG
	MOVWF	VAR1SEG		; CARREGA VARIAVEL AUXILIAR 1 SEG
TMP2:
	MOVLW	T50MSEG		; CARREGA VARIAVEL AUXILIAR 50 MSEG
	MOVWF	TMR0		; AGUARDA TIMER0 CONTAR 50 MSEG
TMP1:
	MOVF	TMR0,W
	BTFSS	STATUS,Z
	GOTO	TMP1
	DECFSZ	VAR1SEG,F	; AGUARDA 1 SEG (50MS X 20MS)
	GOTO	TMP2
	DECFSZ	NX1SEG,F	; AGUARDA TEMPO REFERENTE AO ESTADO
	GOTO	TMP3
	RETLW	0X00

	END			; FIM DO PROGRAMA
;================================================================
